Index: soft/giet_vm/xml/xml_parser.c
===================================================================
--- soft/giet_vm/xml/xml_parser.c	(revision 226)
+++ soft/giet_vm/xml/xml_parser.c	(revision 228)
@@ -30,67 +30,67 @@
 #include  <irq_handler.h>
 
-#define MAX_CLUSTERS	1024
-#define MAX_PSEGS		4096
-#define MAX_VSPACES		1024
-#define MAX_TASKS		4096
-#define MAX_MWMRS		4096
-#define MAX_VSEGS		4096
-#define MAX_VOBJS		8192
-#define MAX_PROCS		1024
-#define MAX_IRQS		8192
-#define MAX_COPROCS		4096
-#define MAX_CP_PORTS	8192
-#define MAX_PERIPHS		8192
-
-#define XML_PARSER_DEBUG   0
+#define MAX_CLUSTERS   1024
+#define MAX_PSEGS      4096
+#define MAX_VSPACES    1024
+#define MAX_TASKS      4096
+#define MAX_MWMRS      4096
+#define MAX_VSEGS      4096
+#define MAX_VOBJS      8192
+#define MAX_PROCS      1024
+#define MAX_IRQS       8192
+#define MAX_COPROCS    4096
+#define MAX_CP_PORTS   8192
+#define MAX_PERIPHS    8192
+
+#define XML_PARSER_DEBUG  0
 
 ///////////////////////////////////////////////////////////////////////////////////
-// 	global variables used to store and index the data structures
+//     global variables used to store and index the data structures
 ///////////////////////////////////////////////////////////////////////////////////
 
-mapping_header_t*       header;
-mapping_cluster_t*      cluster[MAX_CLUSTERS];	// cluster array
-mapping_pseg_t*	        pseg[MAX_PSEGS];		// pseg array
-mapping_vspace_t*       vspace[MAX_VSPACES];	// vspace array
-mapping_vseg_t*	        vseg[MAX_VSEGS];		// vseg array
-mapping_vobj_t*	        vobj[MAX_VOBJS];		// vobj array
-mapping_task_t*	        task[MAX_TASKS];		// task array
-mapping_proc_t*	        proc[MAX_PROCS];		// proc array
-mapping_irq_t*	        irq[MAX_IRQS];			// irq array
-mapping_coproc_t*       coproc[MAX_COPROCS];	// coproc array
-mapping_cp_port_t*	    cp_port[MAX_CP_PORTS];	// coproc port array
-mapping_periph_t*       periph[MAX_PERIPHS];    // peripheral array
+mapping_header_t * header;
+mapping_cluster_t * cluster[MAX_CLUSTERS];  // cluster array
+mapping_pseg_t * pseg[MAX_PSEGS];           // pseg array
+mapping_vspace_t * vspace[MAX_VSPACES];     // vspace array
+mapping_vseg_t * vseg[MAX_VSEGS];           // vseg array
+mapping_vobj_t * vobj[MAX_VOBJS];           // vobj array
+mapping_task_t * task[MAX_TASKS];           // task array
+mapping_proc_t * proc[MAX_PROCS];           // proc array
+mapping_irq_t * irq[MAX_IRQS];              // irq array
+mapping_coproc_t * coproc[MAX_COPROCS];     // coproc array
+mapping_cp_port_t * cp_port[MAX_CP_PORTS];  // coproc port array
+mapping_periph_t * periph[MAX_PERIPHS];     // peripheral array
 
 // Index for the various arrays
 
-unsigned int		cluster_index  = 0;
-unsigned int		vspace_index   = 0;
-unsigned int		global_index   = 0;
-unsigned int		pseg_index     = 0;		
-
-unsigned int		proc_index     = 0;
-unsigned int		proc_loc_index = 0;
-
-unsigned int		irq_index      = 0;
-unsigned int		irq_loc_index  = 0;
-
-unsigned int		coproc_index     = 0;
-unsigned int		coproc_loc_index = 0;
-
-unsigned int		cp_port_index     = 0;
-unsigned int		cp_port_loc_index = 0;
-
-unsigned int		periph_index     = 0;
-unsigned int		periph_loc_index = 0;
-
-unsigned int		vseg_index     = 0;
-unsigned int		vseg_loc_index = 0;
-
-unsigned int		task_index     = 0;
-unsigned int		task_loc_index = 0;
-
-unsigned int		vobj_index     = 0;
-unsigned int		vobj_loc_index = 0;
-unsigned int		vobj_count     = 0;
+unsigned int cluster_index  = 0;
+unsigned int vspace_index = 0;
+unsigned int global_index = 0;
+unsigned int pseg_index = 0;        
+
+unsigned int proc_index = 0;
+unsigned int proc_loc_index = 0;
+
+unsigned int irq_index = 0;
+unsigned int irq_loc_index  = 0;
+
+unsigned int coproc_index = 0;
+unsigned int coproc_loc_index = 0;
+
+unsigned int cp_port_index = 0;
+unsigned int cp_port_loc_index = 0;
+
+unsigned int periph_index = 0;
+unsigned int periph_loc_index = 0;
+
+unsigned int vseg_index = 0;
+unsigned int vseg_loc_index = 0;
+
+unsigned int task_index = 0;
+unsigned int task_loc_index = 0;
+
+unsigned int vobj_index = 0;
+unsigned int vobj_loc_index = 0;
+unsigned int vobj_count = 0;
 
 
@@ -107,14 +107,14 @@
 //needed to generate map_config.ld
 //////////////////////////////////
-unsigned int cluster_y              = 0;
-unsigned int cluster_x              = 0; 
-unsigned int nb_proc_max            = 0; // max number of processors per cluster 
-unsigned int nb_timer_channel_max   = 0; // max number of user timer
-unsigned int nb_dma_channel_max     = 0;
-unsigned int nb_tty_channel         = 0;
-unsigned int nb_ioc_channel         = 0;
-unsigned int nb_nic_channel         = 0;
-unsigned int io_mmu_active          = 0;
-unsigned int use_xicu               = 0xFFFFFFFF;
+unsigned int cluster_y            = 0;
+unsigned int cluster_x            = 0; 
+unsigned int nb_proc_max          = 0; // max number of processors per cluster 
+unsigned int nb_timer_channel_max = 0; // max number of user timer
+unsigned int nb_dma_channel_max   = 0;
+unsigned int nb_tty_channel       = 0;
+unsigned int nb_ioc_channel       = 0;
+unsigned int nb_nic_channel       = 0;
+unsigned int io_mmu_active        = 0;
+unsigned int use_xicu             = 0xFFFFFFFF;
 
 
@@ -124,12 +124,12 @@
 
 //kernel and boot code
-unsigned int kernel_code_base    = 0x80000000;	/* kernel code */
-unsigned int kernel_data_base    = 0x80010000;	/* system cacheable data */
-unsigned int kernel_uncdata_base = 0x80080000;	/* system uncacheable data */
-unsigned int kernel_init_base    = 0x80090000;	/* system init entry */ 
-
-unsigned int boot_code_base      = 0xBFC00000;  /* boot code */
-unsigned int boot_stack_base     = 0xBFC08000;	/* boot temporary stack */ 
-unsigned int boot_mapping_base   = 0xBFC0C000;	/* mapping_info blob */
+unsigned int kernel_code_base    = 0x80000000; /* kernel code */
+unsigned int kernel_data_base    = 0x80010000; /* system cacheable data */
+unsigned int kernel_uncdata_base = 0x80080000; /* system uncacheable data */
+unsigned int kernel_init_base    = 0x80090000; /* system init entry */ 
+
+unsigned int boot_code_base      = 0xBFC00000; /* boot code */
+unsigned int boot_stack_base     = 0xBFC08000; /* boot temporary stack */ 
+unsigned int boot_mapping_base   = 0xBFC0C000; /* mapping_info blob */
 
 //periphs
@@ -151,41 +151,34 @@
 // once all the vspace have been parsed.
 /////////////////////////////////////////////////////////////////////
-typedef struct vobj_ref_s
-{
+typedef struct vobj_ref_s {
     char vspace_name[32];
     char vobj_name[32];
-}vobj_ref_t;
-
-vobj_ref_t*	        cp_port_vobj_ref[MAX_CP_PORTS];	
+} vobj_ref_t;
+
+vobj_ref_t * cp_port_vobj_ref[MAX_CP_PORTS];    
 
 
 //////////////////////////////////////////////////
-unsigned int getIntValue( xmlTextReaderPtr reader, 
-                          const char*      attributeName, 
-                          unsigned int*    ok )
-{
-    unsigned int 	value = 0;
-    unsigned int 	i;
-    char	c;
-
-    char* string = (char*)xmlTextReaderGetAttribute(reader, (const xmlChar*)attributeName);
-
-    if ( string == NULL )  // missing argument
-    {
+unsigned int getIntValue(xmlTextReaderPtr reader, const char * attributeName, unsigned int * ok) {
+    unsigned int value = 0;
+    unsigned int i;
+    char c;
+
+    char * string = (char *) xmlTextReaderGetAttribute(reader, (const xmlChar *) attributeName);
+
+    if (string == NULL) {
+        // missing argument
         *ok = 0;
         return 0;
     }
-    else
-    {
-        if ( (string[0] == '0') && ((string[1] == 'x') || (string[1] == 'X')) )  // Hexa
-        {
-            for ( i = 2 ; (string[i] != 0) && (i < 10) ; i++ )
-            {
+    else {
+        if ((string[0] == '0') && ((string[1] == 'x') || (string[1] == 'X'))) {
+            // Hexa
+            for (i = 2 ; (string[i] != 0) && (i < 10) ; i++) {
                 c = string[i];
-                if      ((c >= '0') && (c <= '9')) value = (value<<4) + string[i] - 48;
-                else if ((c >= 'a') && (c <= 'f')) value = (value<<4) + string[i] - 87;
-                else if ((c >= 'A') && (c <= 'F')) value = (value<<4) + string[i] - 55;
-                else    
-                {
+                if      ((c >= '0') && (c <= '9')) { value = (value << 4) + string[i] - 48; }
+                else if ((c >= 'a') && (c <= 'f')) { value = (value << 4) + string[i] - 87; }
+                else if ((c >= 'A') && (c <= 'F')) { value = (value << 4) + string[i] - 55; }
+                else {
                     *ok = 0;
                     return 0;
@@ -193,12 +186,10 @@
             }
         }
-        else 								// Decimal
-        {
-            for ( i = 0 ; (string[i] != 0) && (i < 9) ; i++ )
-            {
+        else {
+            // Decimal
+            for (i = 0; (string[i] != 0) && (i < 9); i++) {
                 c = string[i];
-                if ((c >= '0') && (c <= '9')) value = (value*10) + string[i] - 48;
-                else 
-                {
+                if ((c >= '0') && (c <= '9')) value = (value * 10) + string[i] - 48;
+                else {
                     *ok = 0;
                     return 0;
@@ -211,22 +202,18 @@
 } // end getIntValue()
 
+
 ///////////////////////////////////////////////
-char* getStringValue ( xmlTextReaderPtr reader, 
-                       const char* 	attributeName, 
-                       unsigned int* 	ok )
-{
-    char* string = (char*)xmlTextReaderGetAttribute(reader, (const xmlChar*)attributeName);
-
-    
-    if ( string == NULL )  // missing argument
-    {
+char * getStringValue(xmlTextReaderPtr reader, const char * attributeName, unsigned int * ok) {
+    char * string = (char *) xmlTextReaderGetAttribute(reader, (const xmlChar *) attributeName);
+
+
+    if (string == NULL) {
+        // missing argument
         *ok = 0;
         return NULL;
     }
-    else
-    {
+    else {
         //we read only string smaller than 32 byte
-        if(strlen(string) > 32)
-        {
+        if (strlen(string) > 32) {
             printf("[XML ERROR] all strings must be less than 32 bytes\n");
             exit(1);
@@ -238,16 +225,13 @@
 } // end getStringValue()
 
+
 ///////////////////////////////////////
-int getPsegId( unsigned int	cluster_id,
-               char*        pseg_name )
-{
+int getPsegId(unsigned int cluster_id, char * pseg_name) {
     unsigned int pseg_id;
     unsigned int pseg_min = cluster[cluster_id]->pseg_offset;
     unsigned int pseg_max = pseg_min + cluster[cluster_id]->psegs;
 
-    for ( pseg_id = pseg_min ; pseg_id < pseg_max ; pseg_id++ )
-    {
-        if ( strcmp(pseg[pseg_id]->name, pseg_name) == 0 ) 
-        {
+    for (pseg_id = pseg_min; pseg_id < pseg_max; pseg_id++) {
+        if (strcmp(pseg[pseg_id]->name, pseg_name) == 0) {
             return pseg_id;
         }
@@ -256,13 +240,11 @@
 }
 
+
 ////////////////////////////////////////////
-int getVspaceId( char*         vspace_name)
-{
+int getVspaceId(char * vspace_name) {
     unsigned int vspace_id;
 
-    for( vspace_id = 0; vspace_id < vspace_index ; vspace_id++)
-    {
-        if( !strcmp(vspace[vspace_id]->name, vspace_name))
-        {
+    for (vspace_id = 0; vspace_id < vspace_index; vspace_id++) {
+        if (!strcmp(vspace[vspace_id]->name, vspace_name)) {
             return vspace_id;
         }
@@ -271,18 +253,14 @@
 }
 
+
 ////////////////////////////////////////////
-int getVobjLocId( unsigned int	vspace_id,
-                  char*		    vobj_name,
-                  unsigned int  vspace_max)
-{
+int getVobjLocId(unsigned int vspace_id, char * vobj_name, unsigned int vspace_max) {
     unsigned int vobj_id;
     unsigned int vobj_min = vspace[vspace_id]->vobj_offset;
     unsigned int vobj_max = vobj_min + vspace_max;
 
-    for ( vobj_id = vobj_min ; vobj_id < vobj_max ; vobj_id++ )
-    {
-        if ( strcmp(vobj[vobj_id]->name, vobj_name) == 0 )
-        {
-             return (vobj_id - vobj_min);
+    for (vobj_id = vobj_min; vobj_id < vobj_max; vobj_id++) {
+        if (strcmp(vobj[vobj_id]->name, vobj_name) == 0) {
+            return (vobj_id - vobj_min);
         }
     }
@@ -290,80 +268,72 @@
 }
 
+
 /////////////////////////////////////////
-void taskNode ( xmlTextReaderPtr reader )
-/////////////////////////////////////////
-{
-    unsigned int 	ok;
-    unsigned int 	value;
-    char*    		str;
-
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-    if ( task_index >= MAX_TASKS )
-    {
+void taskNode(xmlTextReaderPtr reader) {
+    unsigned int ok;
+    unsigned int value;
+    char * str;
+
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+    if (task_index >= MAX_TASKS) {
         printf("[XML ERROR] The number of tasks is larger than %d\n", MAX_TASKS);
     }
 
 #if XML_PARSER_DEBUG
-printf("   task %d\n", task_loc_index);
-#endif
-
-    task[task_index] = (mapping_task_t*)malloc(sizeof(mapping_task_t));
+    printf("   task %d\n", task_loc_index);
+#endif
+
+    task[task_index] = (mapping_task_t *) malloc(sizeof(mapping_task_t));
 
     ////////// get name attribute
     str = getStringValue(reader, "name", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      name = %s\n", str);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      name = %s\n", str);
 #endif
         strncpy( task[task_index]->name, str, 31 );
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <name> attribute for task (%d,%d)\n", 
-               vspace_index, task_loc_index);
+                vspace_index, task_loc_index);
         exit(1);
     }
 
     ///////// get clusterid attribute
-    value = getIntValue(reader,"clusterid", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      clusterid = %x\n", value);
-#endif
-        if ( value >= header->clusters )
-        {
+    value = getIntValue(reader, "clusterid", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      clusterid = %x\n", value);
+#endif
+        if (value >= header->clusters) {
             printf("[XML ERROR] <clusterid> too large for task (%d,%d)\n",
-                   vspace_index, task_loc_index);
+                    vspace_index, task_loc_index);
             exit(1);
         }
         task[task_index]->clusterid = value;
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <clusterid> attribute for task (%d,%d)\n",
-               vspace_index, task_loc_index);
+                vspace_index, task_loc_index);
         exit(1);
     }
 
     ////////// get proclocid attribute
-    value = getIntValue(reader,"proclocid", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      proclocid = %x\n", value);
-#endif
-        if ( value >= cluster[task[task_index]->clusterid]->procs )
-        {
+    value = getIntValue(reader, "proclocid", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      proclocid = %x\n", value);
+#endif
+        if (value >= cluster[task[task_index]->clusterid]->procs) {
             printf("[XML ERROR] <proclocid> too large for task (%d,%d)\n",
-                   vspace_index, task_loc_index);
+                    vspace_index, task_loc_index);
             exit(1);
         }
         task[task_index]->proclocid = value;
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <locprocid> attribute for task (%d,%d)\n", 
                 vspace_index, task_loc_index);
@@ -373,17 +343,14 @@
     ////////// get stackname attribute
     str = getStringValue(reader, "stackname" , &ok);
-    if ( ok )
-    {
-        int index = getVobjLocId( vspace_index, str , vobj_loc_index);
-        if ( index >= 0 ) 
-        {
-#if XML_PARSER_DEBUG
-printf("      stackname = %s\n", str);
-printf("      stackid   = %d\n", index);
+    if (ok) {
+        int index = getVobjLocId(vspace_index, str , vobj_loc_index);
+        if (index >= 0) {
+#if XML_PARSER_DEBUG
+            printf("      stackname = %s\n", str);
+            printf("      stackid   = %d\n", index);
 #endif
             task[task_index]->vobjlocid = index;
         }
-        else              
-        {
+        else {
             printf("[XML ERROR] illegal or missing <stackname> for task (%d,%d)\n", 
                     vspace_index, task_loc_index);
@@ -391,6 +358,5 @@
         }
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <stackname> for task (%d,%d)\n", 
                 vspace_index, task_loc_index);
@@ -399,14 +365,12 @@
 
     ////////// get startid  attribute
-    value = getIntValue(reader,"startid", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      startid = %x\n", value);
+    value = getIntValue(reader, "startid", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      startid = %x\n", value);
 #endif
         task[task_index]->startid = value;
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <startid> attribute for task (%d,%d)\n", 
                 vspace_index, task_loc_index);
@@ -415,56 +379,48 @@
 
     /////////// get usetty  attribute (optionnal : 0 if missing)
-    value = getIntValue(reader,"usetty", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      usetty = %x\n", value);
+    value = getIntValue(reader, "usetty", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      usetty = %x\n", value);
 #endif
         task[task_index]->use_tty = value;
     }  
-    else
-    {
+    else {
         task[task_index]->use_tty = 0;
     }
 
     /////////// get usenic  attribute (optionnal : 0 if missing)
-    value = getIntValue(reader,"usenic", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      usenic = %x\n", value);
+    value = getIntValue(reader, "usenic", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      usenic = %x\n", value);
 #endif
         task[task_index]->use_nic = value;
     }  
-    else
-    {
+    else {
         task[task_index]->use_nic = 0;
     }
 
     /////////// get usetimer attribute (optionnal : 0 if missing)
-    value = getIntValue(reader,"usetimer", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      usetimer = %x\n", value);
+    value = getIntValue(reader, "usetimer", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      usetimer = %x\n", value);
 #endif
         task[task_index]->use_timer = value;
     }  
-    else
-    {
+    else {
         task[task_index]->use_timer = 0;
     }
 
     /////////// get usefbdma  attribute (optionnal : 0 if missing)
-    value = getIntValue(reader,"usefbdma", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      usefbdma = %x\n", value);
+    value = getIntValue(reader, "usefbdma", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      usefbdma = %x\n", value);
 #endif
         task[task_index]->use_fbdma = value;
-    }  
-    else
-    {
+    }
+    else {
         task[task_index]->use_fbdma = 0;
     }
@@ -474,16 +430,16 @@
 } // end taskNode()
 
+
 //////////////////////////////////////////
-void  vobjNode ( xmlTextReaderPtr reader )
-//////////////////////////////////////////
-{
-    unsigned int 	ok;
-    unsigned int 	value;
-    char*    		str;
-
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-    if ( vobj_index >= MAX_VOBJS )
-    {
+void vobjNode(xmlTextReaderPtr reader) {
+    unsigned int ok;
+    unsigned int value;
+    char * str;
+
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+    if (vobj_index >= MAX_VOBJS) {
         printf("[XML ERROR] The number of vobjs is larger than %d\n", MAX_VSEGS);
         exit(1);
@@ -491,20 +447,18 @@
 
 #if XML_PARSER_DEBUG
-printf("      vobj %d\n", vobj_loc_index);
-#endif
-
-    vobj[vobj_index] = (mapping_vobj_t*)malloc(sizeof(mapping_vobj_t));
+    printf("      vobj %d\n", vobj_loc_index);
+#endif
+
+    vobj[vobj_index] = (mapping_vobj_t *) malloc(sizeof(mapping_vobj_t));
 
     ///////// get name attribute
     str = getStringValue(reader, "name", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        name = %s\n", str);
-#endif
-        strncpy( vobj[vobj_index]->name, str, 31);
-    }
-    else
-    {
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        name = %s\n", str);
+#endif
+        strncpy(vobj[vobj_index]->name, str, 31);
+    }
+    else {
         printf("[XML ERROR] illegal or missing <name> attribute for vobj (%d,%d)\n", 
                 vseg_index, vobj_loc_index);
@@ -515,13 +469,11 @@
     str = getStringValue(reader, "type", &ok);
 #if XML_PARSER_DEBUG
-printf("        type = %s\n", str);
-#endif
-    if (ok && (strcmp(str, "ELF") == 0))
-    {
+    printf("        type = %s\n", str);
+#endif
+    if (ok && (strcmp(str, "ELF") == 0)) {
         vobj[vobj_index]->type = VOBJ_TYPE_ELF;
 
         //check that this vobj is the first in vseg
-        if(vobj_count != 0) 
-        {
+        if (vobj_count != 0) {
             printf("[XML ERROR] an ELF vobj must be alone in a vseg (%d,%d)\n", 
                     vspace_index, vobj_loc_index);
@@ -529,13 +481,14 @@
         }
     }
-    else if (ok && (strcmp(str, "BLOB")    == 0)) vobj[vobj_index]->type = VOBJ_TYPE_BLOB;
-    else if (ok && (strcmp(str, "PTAB")    == 0)) vobj[vobj_index]->type = VOBJ_TYPE_PTAB;
-    else if (ok && (strcmp(str, "PERI")    == 0)) vobj[vobj_index]->type = VOBJ_TYPE_PERI;
-    else if (ok && (strcmp(str, "MWMR")    == 0)) vobj[vobj_index]->type = VOBJ_TYPE_MWMR;
-    else if (ok && (strcmp(str, "LOCK")    == 0)) vobj[vobj_index]->type = VOBJ_TYPE_LOCK;
-    else if (ok && (strcmp(str, "BUFFER")  == 0)) vobj[vobj_index]->type = VOBJ_TYPE_BUFFER;
-    else if (ok && (strcmp(str, "BARRIER") == 0)) vobj[vobj_index]->type = VOBJ_TYPE_BARRIER;
-    else
-    {
+    else if (ok && (strcmp(str, "BLOB")     == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_BLOB; }
+    else if (ok && (strcmp(str, "PTAB")     == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_PTAB; }
+    else if (ok && (strcmp(str, "PERI")     == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_PERI; }
+    else if (ok && (strcmp(str, "MWMR")     == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_MWMR; }
+    else if (ok && (strcmp(str, "LOCK")     == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_LOCK; }
+    else if (ok && (strcmp(str, "BUFFER")   == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_BUFFER; }
+    else if (ok && (strcmp(str, "BARRIER")  == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_BARRIER; }
+    else if (ok && (strcmp(str, "CONST")    == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_CONST; }
+    else if (ok && (strcmp(str, "MEMSPACE") == 0)) { vobj[vobj_index]->type = VOBJ_TYPE_MEMSPACE; }
+    else {
         printf("[XML ERROR] illegal or missing <type> attribute for vobj (%d,%d)\n", 
                 vspace_index, vobj_loc_index);
@@ -544,14 +497,12 @@
 
     ////////// get length attribute 
-    value = getIntValue(reader,"length", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        length = %d\n", value);
+    value = getIntValue(reader, "length", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        length = %d\n", value);
 #endif
         vobj[vobj_index]->length = value;
     }  
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <length> attribute for vobj (%d,%d)\n", 
                 vspace_index, vobj_loc_index);
@@ -560,14 +511,12 @@
 
     ////////// get align attribute (optional : 0 if missing)
-    value = getIntValue(reader,"align", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        align = %d\n", value);
+    value = getIntValue(reader, "align", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        align = %d\n", value);
 #endif
         vobj[vobj_index]->align = value;
     }  
-    else
-    {
+    else {
         vobj[vobj_index]->align = 0;
     }
@@ -575,32 +524,28 @@
     ////////// get binpath attribute (optional : '\0' if missing)
     str = getStringValue(reader, "binpath", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        binpath = %s\n", str);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        binpath = %s\n", str);
 #endif
         strncpy(vobj[vobj_index]->binpath, str, 63);
     }  
-    else
-    {
+    else {
         vobj[vobj_index]->binpath[0] = '\0';
     }
-    
+
     ////////// get init attribute (mandatory for mwmr and barrier)
-    value = getIntValue(reader,"init", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("        init  = %d\n", value);
+    value = getIntValue(reader, "init", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("        init  = %d\n", value);
 #endif
         vobj[vobj_index]->init = value;
     }  
-    else
-    {
-        if( (vobj[vobj_index]->type == VOBJ_TYPE_MWMR) || 
-            (vobj[vobj_index]->type == VOBJ_TYPE_BARRIER) )
-        {
+    else {
+        if ((vobj[vobj_index]->type == VOBJ_TYPE_MWMR) || 
+                (vobj[vobj_index]->type == VOBJ_TYPE_BARRIER) ||
+                (vobj[vobj_index]->type == VOBJ_TYPE_CONST)) {
             printf("[XML ERROR] illegal or missing <value> attribute for vobj (%d,%d). \
-                                        All MWMR or BARRIER vobj must have a init value \n", 
+                    All MWMR or BARRIER vobj must have a init value \n", 
                     vspace_index, vobj_loc_index);
             exit(1);
@@ -614,18 +559,18 @@
 } // end vobjNode()
 
+
 //////////////////////////////////////////
-void  vsegNode ( xmlTextReaderPtr reader )
-//////////////////////////////////////////
-{
-    unsigned int 	ok;
-    unsigned int 	value;
-    char*    		str;
-
-	vobj_count = 0;
-
-    if ( xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT ) return;
-
-    if ( vseg_index >= MAX_VSEGS )
-    {
+void vsegNode(xmlTextReaderPtr reader) {
+    unsigned int ok;
+    unsigned int value;
+    char * str;
+
+    vobj_count = 0;
+
+    if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_END_ELEMENT) {
+        return;
+    }
+
+    if (vseg_index >= MAX_VSEGS) {
         printf("[XML ERROR] The number of vsegs is larger than %d\n", MAX_VSEGS);
         exit(1);
@@ -633,26 +578,24 @@
 
 #if XML_PARSER_DEBUG
-printf("    vseg %d\n", vseg_loc_index);
-#endif
-
-    vseg[vseg_index] = (mapping_vseg_t*)malloc(sizeof(mapping_vseg_t));
-    
+    printf("    vseg %d\n", vseg_loc_index);
+#endif
+
+    vseg[vseg_index] = (mapping_vseg_t *) malloc(sizeof(mapping_vseg_t));
+
     ////////// set vobj_offset attributes
     vseg[vseg_index]->vobj_offset = vobj_index;
 #if XML_PARSER_DEBUG
-printf("      vobj_offset = %d\n", vobj_index);
+    printf("      vobj_offset = %d\n", vobj_index);
 #endif
 
     ///////// get name attribute
     str = getStringValue(reader, "name", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      name = %s\n", str);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      name = %s\n", str);
 #endif
         strncpy( vseg[vseg_index]->name, str, 31);
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <name> attribute for vseg (%d,%d)\n", 
                 vspace_index, vseg_loc_index);
@@ -661,28 +604,24 @@
 
     ////////// get ident attribute (optional : 0 if missing)
-    value = getIntValue(reader,"ident", &ok);
-    if ( ok )
-    {
-#if XML_PARSER_DEBUG
-printf("      ident = %d\n", value);
+    value = getIntValue(reader, "ident", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      ident = %d\n", value);
 #endif
         vseg[vseg_index]->ident = value;
     }  
-    else
-    {
+    else {
         vseg[vseg_index]->ident = 0;
     }
 
     /////////// get vbase attribute
-    value = getIntValue(reader,"vbase", &ok);
-    if ( ok ) 
-    {
-#if XML_PARSER_DEBUG
-printf("      vbase = 0x%x\n", value);
+    value = getIntValue(reader, "vbase", &ok);
+    if (ok) {
+#if XML_PARSER_DEBUG
+        printf("      vbase = 0x%x\n", value);
 #endif
         vseg[vseg_index]->vbase = value;
     }
-    else
-    {
+    else {
         printf("[XML ERROR] illegal or missing <vbase> attribute for vseg (%d,%d)\n", 
                 vspace_index, vseg_loc_index);
